import { Model, Types } from "ada-cloud-util/boost";
import { table, field } from "ada-cloud-util/boost/annotation"

@table({ name: "{{ tableName }}" })
class {{ upperTableCamelName }}Model extends Model { 
    {{each fields value key}}
    @field({
        {{ value.prime?'prime: true,\n        ':'' }}name: "{{ value.field }}",
        type: {{ value.type }},
        valid: {{@ value.validStr }}
    })
    {{ key }} = {{ value.defaultValue||'null' }};
    {{/each}}
}

export default {{ upperTableCamelName }}Model;