class Queue {
    constructor() {
        this._list = [];
        this._working = false;
    }

    add({ fn, parameter, scope }) {
        this._list.push({ fn, parameter, scope });
        this._excute();
    }

    _excute() {
        if (this._list.length > 0) {
            if (!this._working) {
                this._working = true;
                let { fn, parameter, scope } = this._list.shift();
                Promise.resolve().then(() => {
                    return new Promise(resolve => {
                        Promise.resolve().then(() => fn.call(scope, parameter)).then(() => resolve(), () => resolve());
                    });
                }).then(() => {
                    this._working = false;
                    this._excute();
                });
            }
        }
    }
}

module.exports = Queue;