import { Service, MysqlDao } from "ada-cloud-util/boost";
import { dao, transaction } from "ada-cloud-util/boost/annotation";
import {{ upperTableCamelName }}Model from "./../model/{{ tableName }}";

class {{ upperTableCamelName }}Service extends Service {

    @dao(MysqlDao)
    dao = null;

    get{{ upperTableCamelName }}List({ entity = {}, query = {} }) {
        return this.dao.find(new {{ upperTableCamelName }}Model().set(entity), query);
    }

    get{{ upperTableCamelName }}Detail(entity = {}) {
        return this.dao.find(new {{ upperTableCamelName }}Model().set(entity)).then(list => list[0]);
    }

    @transaction()
    add{{ upperTableCamelName }}(model) {
        return this.dao.insert(model);
    }

    @transaction()
    edit{{ upperTableCamelName }}(model) {
        return this.dao.update(model);
    }

    @transaction()
    remove{{ upperTableCamelName }}(model) {
        return this.dao.remove(model);
    }
}

export default {{ upperTableCamelName }}Service;