const BaseResult = require("../base");
const { RESULTCODE } = require("../const");

class UnalidResult extends BaseResult {
    constructor(message) {
        super({ code: RESULTCODE.UNVALID, message });
    }
}

UnalidResult.REQUIRED = 'REQUIRED';
UnalidResult.LESSTHENMIN = 'LESSTHENMIN';
UnalidResult.MORETHENMAX = 'MORETHENMAX';
UnalidResult.REGEX = 'REGEX';
UnalidResult.TYPEERROR = 'TYPEERROR';

module.exports = UnalidResult;